#include <R.h>
#include <Rinternals.h>
#include <stdlib.h> // for NULL
#include <R_ext/Rdynload.h>

/* .Call calls */
extern SEXP cve(SEXP X, SEXP Y, SEXP k, SEXP h,
                SEXP method,
                SEXP V, // initial
                SEXP momentum, SEXP tau, SEXP tol,
                SEXP slack, SEXP gamma,
                SEXP maxIter, SEXP attempts,
                SEXP logger, SEXP loggerEnv);

static const R_CallMethodDef CallEntries[] = {
    {"cve", (DL_FUNC) &cve, 15},
    {NULL, NULL, 0}
};

/* Restrict C entrypoints to registered routines. */
void R_initCVE(DllInfo *dll) {
    R_registerRoutines(dll, NULL, CallEntries, NULL, NULL);
    R_useDynamicSymbols(dll, FALSE);
}
